--[[
	Cargo Tab written by Seryn
	version 1.1.0
	based on mdi-targetlist tab system by draugath
--]]

declare("Cargo_tab", {
	version = "1.1.0",
})


local T = {
	Tab = {
		title = "Cargo",
		columns = {
			{
				title = "Index",
				width = 0,
			},
			{
				title = "Item",
				width = 1,
			},
		},
		filters = {
			{
				title = "Cargo",
			},
			{
				title = "Drops",
			},
			{
				title = "Features",
			},
			{
				title = "Manu",
			},
		},
		--------------
		

		currentList = {},
		filter_index = -1,
	}
}

Cargo_tab.T = T
T.Tab.cargoList = { 
	{
		"1",
		"\127ff7a70Synthetic Silksteel",
	},
	{
		"2",
		"\127ffa76bNeural Nodules",
	},
	{ 
		"3",
		"\127ffe384Guardian Processor Cores",
	},
	{ 
		"4",
		"\127ffb37aDentek Processor Cores",
	},
	{ 
		"5",
		"\127ffe5b1Artemis Processor Cores",
	},
	{	
		"6",
		"\127fff190Avalon Torpedos",
	},
	{	
		"7",
		"\127ff7070Hive Queen drops",
	},
	{	
		"8",
		"\127a168f1Hive Positron Blaster",
	},
	
}

T.Tab.cargoList2 = { 
	{
		"1",
		"\127b07395Law Enforcement Neutron Blaster",
	},
	{	
		"2",
		"\127d8808eFluid Formable Silksteel Alloy",
	},
	{	
		"3",
		"\127ffa583Fused Composite Plating",
	},
	{	
		"4",
		"\127ffc38cRarified Heliocene Alloy",
	},
	{	
		"5",
		"\127fff190Reinforced Bulkhead",
	},
	{	
		"6",
		"\127ff7070Data Aggregator",
	},
	{	
		"7",
		"\127a168f1Samoflange",
	},
	{	
		"8",
		"\1277770ffObserver Optics",
	},
}
	
T.Tab.featureList = { 
	{
		"1",
		"\127ffc38c** Autotarget ON/OFF",
	},
	{
		"2",
		"\127ffa583** Autotarget Distance Check",
	},
	{	
		"3",
		"\127ffc38c** Post Target to Group",
	},
	{	
		"4",
		"\127ffa583** Post Target to Guild",
	},
	{	
		"5",
		"\127ffc38c** Post Target to active channel",
	},
	{	
		"6",
		"\127ffa583** Plot route home",
	},
	{	
		"7",
		"\127ffc38c** Set target to friendly",
	},
	{	
		"8",
		"\127ffa583** Set target to hostile",
	}
}

T.Tab.manuLocationList = {
	{
		"1",
		"\127fff190** Home",
	},
	{ 
		"2",
		"\127afcbff** Nyrius F-6",
	},
	{	
		"3",
		"\127fff190** Pelatus C-12",
	},
	{	
		"4",
		"\127afcbff** Bractus M-14",
	},
	{	
		"5",
		"\127fff190** Latos I-8",
	},
	{	
		"6",
		"\127afcbff** Odia M-14",
	},
	{	
		"7",
		"\127fff190** Latos N-2",
	},
	{
		"8",
		"\127afcbff** Dau L-10",
	},
}




T.Tab.autoTarget = false
T.Tab.distanceOnOffSwitch = false
T.Tab.targetMode = 1
T.Tab.targetTimer = Timer()
T.Tab.distanceTimer = Timer()
T.Tab.autoLoadCargo = false
T.Tab.autoUnloadCargo = false

local setRadarSelection = radar.SetRadarSelection
local pCommand = gkinterface.GKProcessCommand

-- tab change to Cargo, update list.. maybe useful later
function T.Tab:TARGETLIST_TAB_CHANGED()
	self.is_active = targetlist.API.IsActiveTab(T.Tab)
	if (self.is_active) then
		targetlist.API.UpdateDisplay(self, self.currentList)
	end
end


function T.Tab:ChangeFilter(index, page)
	T.Tab.filter_index = index
	if self.filter_index == 1 then
		T.Tab.currentList = T.Tab.cargoList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 2 then
		T.Tab.currentList = T.Tab.cargoList2
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 3 then
		T.Tab.currentList = T.Tab.featureList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 4 then
		T.Tab.currentList = T.Tab.manuLocationList
		targetlist.API.UpdateDisplay(self, self.currentList)
	end
end


-- select target to find cargo 
function T.Tab:ChangeTarget(_, listEntryID)
	-- cargo finder
	if self.filter_index == 1 then
		local listEntryID = listEntryID
		local searchItem = " "
		-- search for silksteel
		if listEntryID == 1 then
			searchItem = "Synthetic Silksteel"
		-- search for nodules
		elseif listEntryID == 2 then
			searchItem = "Neural Nodule"
		-- search for guardian cores
		elseif listEntryID == 3 then
			searchItem = "Guardian Processor"
		-- search for dentek cores
		elseif listEntryID == 4 then
			searchItem = "Dentek Processor"
		-- search for artemis cores
		elseif listEntryID == 5 then
			searchItem = "Artemis Processor"
		-- search for Avalons
		elseif listEntryID == 6 then
			searchItem = "Avalon"
		-- search queen drops
		elseif listEntryID == 7 then
			searchItem = "Queen"
		-- search observer optics
		elseif listEntryID == 8 then
			searchItem = "Hive Positron"
		--
		elseif listEntryID == 9 then
			return
		--
		elseif listEntryID == 10 then
			return
		end

		local currentItem = " "
		local itemFound = 0
		-- start radar search at zero
		setRadarSelection(0,0)
		-- search through all items in range until something matches
		while (currentItem ~= nil and itemFound == 0) do
			pCommand("RadarNext");
			-- check found item 
			currentItem = GetTargetInfo()
			-- compare current item with the search item
			if (currentItem ~= nil and string.find(string.lower(currentItem),string.lower(searchItem))) then
				-- end the loop, cargo found
				itemFound = 1
			end
		end
		-- nothing found, still zero
		if itemFound == 0 then
			print("\127504aff** No cargo in range with: " .. searchItem .. "\127o")
		end

	-- second set of search items
	elseif self.filter_index == 2 then
		local listEntryID = listEntryID
		local searchItem = " "
		-- find lenb
		if listEntryID == 1 then
			searchItem = "Law Enforcement"
		-- find ffsa
		elseif listEntryID == 2 then
			searchItem = "Fluid Formable"
		-- find fcp 
		elseif listEntryID == 3 then
			searchItem = "Fused Composite"
		-- search rarified heliocene alloy
		elseif listEntryID == 4 then
			searchItem = "Rarified Heliocene"
		-- find reinforced bulkheads
		elseif listEntryID == 5 then
			searchItem = "Reinforced Bulkhead"
		-- find data aggy
		elseif listEntryID == 6 then
			searchItem = "Data Aggregator"
		-- find samoflange
		elseif listEntryID == 7 then
			searchItem = "Samoflange"
		--
		elseif listEntryID == 8 then
			searchItem = "Observer Optics"
		--
		elseif listEntryID == 9 then
			return
		--
		elseif listEntryID == 10 then
			return
		end
		
		local currentItem = " "
		local itemFound = 0
		-- start radar search at zero
		setRadarSelection(0,0)
		-- search through all items in range until something matches
		while (currentItem ~= nil and itemFound == 0) do
			pCommand("RadarNext");
			-- check found item 
			currentItem = GetTargetInfo()
			-- compare current item with the search item
			if (currentItem ~= nil and string.find(string.lower(currentItem),string.lower(searchItem))) then
				-- end the loop, cargo found
				itemFound = 1
			end
		end
		-- nothing found, still zero
		if itemFound == 0 then
			print("\127504aff** No cargo in range with: " .. searchItem .. "\127o")
		end


	-- various tools
	elseif self.filter_index == 3 then
		local listEntryID = listEntryID
		-- autotarget on/off switch
		if listEntryID == 1 then
			if T.Tab.autoTarget == false then
				T.Tab.autoTarget = true
				RegisterEvent(T.Tab.playerDied, "PLAYER_DIED")
				print("\127a134eb** AutoTarget: ON\127o")
			elseif T.Tab.autoTarget == true then
				T.Tab.autoTarget = false
				T.Tab.distanceOnOffSwitch = false
				UnregisterEvent(T.Tab.playerDied, "PLAYER_DIED")
				print("\127a134eb** AutoTarget: OFF\127o")	
			end
		-- autotarget distance check
		elseif listEntryID == 2 then
			if T.Tab.distanceOnOffSwitch == false then
				-- set variable to true to turn the check on and meet if condition
				T.Tab.distanceOnOffSwitch = true;
				print("\127a134eb** AutoTarget: Distance check ON\127o");
				-- call the function, this time with a real function call
				T.Tab.checkDistance()
			elseif T.Tab.distanceOnOffSwitch == true then
				-- kill any remaining timers to prevent unforseen behavior
				if T.Tab.distanceTimer:IsActive() then T.Tab.distanceTimer:Kill() end
				-- set condition to false to interrupt the loop
				T.Tab.distanceOnOffSwitch = false
				print("\127a134eb** AutoTarget: Distance check OFF\127o");
			else
				T.Tab.distanceOnOffSwitch = false
				print("\127a134ebSomething went wrong. Disabling distance check.\127o")
			end
			
		-- post target to group
		elseif listEntryID == 3 then
			T.Tab.targetDetails("GROUP")

		-- post target to guild
		elseif listEntryID == 4 then
			T.Tab.targetDetails("GUILD")

		-- post target to active channel
		elseif listEntryID == 5 then
			T.Tab.targetDetails("CHANNEL")

		-- plot route to home station
		elseif listEntryID == 6 then
			local homeSectorID = GetHomeStation()
			local homeLocation = AbbrLocationStr(homeSectorID)
			NavRoute.SetFinalDestination(homeSectorID)
			print("\1277dd4ff** Navroute plotted to: " .. homeLocation .. "\127o")

		-- turn target friendly on radar
		elseif listEntryID == 7 then
			local delayTimer = Timer()
			local targetName, targetHealth, targetDistance, targetFactionid, targetGuild, targetShip = GetTargetInfo()
			local targetCharId = GetCharacterIDByName(targetName)
			local targetNodeID = GetPlayerNodeID(targetCharId)
			function GetFriendlyStatus(targetCharID)
				return 3
			end
    		delayTimer:SetTimeout(64, function() UpdateRadarFriendlyStatus(targetNodeID) end)

		-- turn target hostile on radar
		elseif listEntryID == 8 then
			local delayTimer = Timer()
			local targetName, targetHealth, targetDistance, targetFactionid, targetGuild, targetShip = GetTargetInfo()
			local targetCharId = GetCharacterIDByName(targetName)
			local targetNodeID = GetPlayerNodeID(targetCharId)
			function GetFriendlyStatus(targetCharID)
				return 0
			end
    		delayTimer:SetTimeout(64, function() UpdateRadarFriendlyStatus(targetNodeID) end)

		-- autoload on/off
		elseif listEntryID == 9 then
			return
		-- autounload on/off
		elseif listEntryID == 10 then
			return
		end

	--?
	elseif self.filter_index == 4 then
		local listEntryID = listEntryID
		-- plot to home
		if listEntryID == 1 then
			local homeSectorID = GetHomeStation()
			local homeLocation = AbbrLocationStr(homeSectorID)
			NavRoute.SetFinalDestination(homeSectorID)
			print("\1277dd4ff** Navroute plotted to: " .. homeLocation .. "\127o")
		
		-- plot to nyrius f-6
		elseif listEntryID == 2 then
			local sectorID = 4438
			local sectorLocation = AbbrLocationStr(sectorID)
			NavRoute.SetFinalDestination(sectorID)
			print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")

			-- plot to pel c12
		elseif listEntryID == 3 then
			local sectorID = 4019
			local sectorLocation = AbbrLocationStr(sectorID)
			NavRoute.SetFinalDestination(sectorID)
			print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")

		-- plot to brac m14
		elseif listEntryID == 4 then
			local sectorID = 4317
			local sectorLocation = AbbrLocationStr(sectorID)
			NavRoute.SetFinalDestination(sectorID)
			print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")

		-- plot to lat i8
		elseif listEntryID == 5 then
			local sectorID = 5753
			local sectorLocation = AbbrLocationStr(sectorID)
			NavRoute.SetFinalDestination(sectorID)
			print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")
		
		-- plot to odia m-14
		elseif listEntryID == 6 then
			local sectorID = 5597
			local sectorLocation = AbbrLocationStr(sectorID)
			NavRoute.SetFinalDestination(sectorID)
			print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")

		-- latos n-2
		elseif listEntryID == 7 then
			local sectorID = 5662
			local sectorLocation = AbbrLocationStr(sectorID)
			NavRoute.SetFinalDestination(sectorID)
			print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")

		-- dau l-10
		elseif listEntryID == 8 then
			local sectorID = 4764
			local sectorLocation = AbbrLocationStr(sectorID)
			NavRoute.SetFinalDestination(sectorID)
			print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")

		--
		elseif listEntryID == 9 then
			return

		--
		elseif listEntryID == 10 then
			return

		end
	end
end




-- function to target nearest enemy once current target dies
function T.Tab.playerDied(event, victim, killer, weapon)
    -- assign all the event data to variables
    local owncharID = GetCharacterID()
    local ownName = GetPlayerName(owncharID)
    local victimName = GetPlayerName(victim)
    local killerName = GetPlayerName(killer)
    local usedWeapon = weapon
    local currentTarget = GetTargetInfo()
	-- if you still have a target, don't switch, someone else killed a bot
	if currentTarget ~= nil then
		return
	-- if you killed a bot, switch to nearest one
	elseif killerName == ownName then
		pCommand("RadarNextNearestEnemy")
	-- someone else killed your target, switch to nearest
	else
		pCommand("RadarNextNearestEnemy")
	end
    
end


-- distance check every 4 seconds, retarget nearest hostile 
function T.Tab.checkDistance()
	if T.Tab.autoTarget == true then
		if T.Tab.distanceOnOffSwitch == true then
			-- target nearest hostile
			pCommand("RadarNextNearestEnemy")
			-- re-allocate the timer because timers in vo are stupid af
			T.Tab.distanceTimer = Timer()
			-- recall the function after 4 seconds, function call needs to be a variable and not a function call because lua is dumb
			T.Tab.distanceTimer:SetTimeout(4000, T.Tab.checkDistance)
		end
	else
		print("\127a134eb** AutoTarget is OFF, distance check disabled.\127o")
	end
end



local floor = math.floor
local targetString = ""

-- send target to various chats
function T.Tab.targetDetails(channel)
    -- only fill in if there are target details
	if GetTargetInfo() ~= nil then
        -- fill in all the available stats
		local targetName, targetHealth, targetDistance, targetFactionID, targetGuild, targetShip = GetTargetInfo()
		local targetCharID = GetCharacterIDByName(targetName)
        -- if roids, only report name and distance
		if targetName == "Asteroid" or targetName == "Ice Crystal" then 
            targetString = "Target: " .. targetName .. " at " .. floor(targetDistance) .. "m."
        -- if it has health, it must be a player
        elseif targetHealth ~= nil then
            local factionInfo = FactionName[targetFactionID] or "";
            local guildTag = "[" .. targetGuild .. "]" or "";
            if targetGuild ~= "" then
                targetString = "Target: " .. guildTag .. targetName .. " (" .. factionInfo .. "), (" .. targetCharID .. "), piloting " .. Article(targetShip) .. " with ".. floor(targetHealth*100) .."% health at ".. floor(targetDistance) .. "m."  
            else
                targetString = "Target: " .. targetName .. " (" .. factionInfo .. "), (" .. targetCharID .. "), piloting " .. Article(targetShip) .." with " .. floor(targetHealth*100) .."% health at " .. floor(targetDistance) .. "m."
            end
		-- if it's neither roid or player, it must be cargo. separated for future additions
        else 
            targetString = "Target: " .. targetName .. " at " .. floor(targetDistance) .. "m."
		end
        -- send the actual targetString to channel 
        SendChat(targetString, channel:upper())
	end
end







-- check if plugin was loaded correctly
function T.Tab:PLUGINS_LOADED()
	if (isdeclared("targetlist") and targetlist.API) then
		if (targetlist.API.Version >= 1) then
			targetlist.API.RegisterTab(T.Tab)
		else
			print("\1277dd4ffMDI-TargetList API version is not compatible. Cargo Tab was not loaded.\127o")
		end
	end
end

-- check if targetlist is even installed
function T.Tab:PLAYER_ENTERED_GAME()
	if (not (isdeclared("targetlist") and targetlist.API)) then
		print("\1277dd4ffCargo Tab for MDI-TargetList requires version 4 or higher.\127o")
	end
end



RegisterEvent(T.Tab, "TARGETLIST_TAB_CHANGED")
RegisterEvent(T.Tab, "PLUGINS_LOADED")
RegisterEvent(T.Tab, "PLAYER_ENTERED_GAME")
